/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CARG                                                     */
/* Tabela : CARGO                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CARG' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CARG
GO

CREATE TRIGGER DTULTATU_CARG
ON CARGO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CARGO', null, 'CDCARGO='+ CDCARGO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CARGO
      SET DTULTATUCARG = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CARGO.CDCARGO,0) = ISNULL(INSERTED.CDCARGO,0)) AND
            (ISNULL(CARGO.NMCARGO,0) = ISNULL(INSERTED.NMCARGO,0));
   END;
END;
GO

