var Cus01700_CustoRealizadoGlobalDoPeriodo = function (ScreenService, General, GeneralServices, templateManager) {
	
	this.defaultValues = function(widget) {
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}
		
		var PERIODO = widget.getField('PERIODO');

		var defaultValue = {
			start: getLocalVar('DTPROCESSA'),
			end: getLocalVar('DTPROCESSA'),
			formattedStart: getLocalVar('DTPROCESSA'),
			formattedEnd: getLocalVar('DTPROCESSA')
		};
		
		PERIODO.defaultValue = defaultValue;
		widget.currentRow.DTINICIAL = getLocalVar('DTPROCESSA');
		widget.currentRow.DTFINAL = getLocalVar('DTPROCESSA');
		widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + ' | ' + getLocalVar('NMFILIAL');
		widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');

		GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
			if (callback.dataset.defaulttipocusto[0]) {
				widget.getField('NMTIPOCUSTO').setValue(callback.dataset.defaulttipocusto[0].NMTIPOCUSTO);
				widget.currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			}
		});
	};

	this.atualizaListaDeServico = function(widget) {
		var grupoServicos = '';
		var currentRow = widget.currentRow;

		if (currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.NMGRUPSERV.length) {
				grupoServicos = currentRow.NMGRUPSERV.join('_');
			}
			else {
				grupoServicos = '';
			}
		}
		else {
			grupoServicos = 'T';
		}
		General.onClickDependentField(widget.getField('NMSERVICO'), {
			CDGRUPSERV: grupoServicos
		});
	};

	this.validaData = function(currentRow) {
		var dataInicial = currentRow.DTINICIAL ? moment(currentRow.DTINICIAL, 'DD/MM/YYYY')._d : null;
		var dataFinal = currentRow.DTFINAL ? moment(currentRow.DTFINAL, 'DD/MM/YYYY')._d : null;
		var mensagem = "A data inicial deve ser menor ou igual a data final.";

		if (dataInicial && dataFinal && dataFinal < dataInicial) {
			ScreenService.showMessage(mensagem);
			return false;
		}

		dataIni = currentRow.DTINICIAL;
		dataFim = currentRow.DTFINAL;

		var primeiroDia = moment(dataIni, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
		var ultimoDia = moment(dataFim, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');

		currentRow.DTMESINIC = primeiroDia;
		currentRow.DTMESFINA = ultimoDia;
		return true;
	};

	this.geraDataSource = function(widget, dataSource) {
		var dataSourceNivelProduto = [];
		var maiorNivel = getLocalVar('CDPICTPROD').split('.').length;

		for (var i = 0; i < maiorNivel; i++) {
			dataSourceNivelProduto.push({
				value: i.toString(),
				name: i.toString()
			});
		}
		widget.getField('NMTAMACNIVEL').dataSource.data = dataSourceNivelProduto;
		widget.currentRow.NMTAMACNIVEL = '0';
	};

	this.geraNivelProduto = function(widget) {
		var nivelProduto = getLocalVar('CDPICTPROD').split('.');
		var nivel = widget.getField('NMTAMACNIVEL').value();
		var stringMascara = '';
		for (pos = 0; pos < nivel; pos++) {
			stringMascara += nivelProduto[pos];
		}
		widget.getField('NRTAMACNIVEL').setValue(stringMascara.length);
	};

	this.ordenaProduto = function(widget) {
		var ordenacao_tipo = widget.getField('ORDENA').value();
		if (ordenacao_tipo == "0") {
			var tamanho_mascara = this.concatenaArrayMascara(getLocalVar('CDPICTPROD').split('.'));
			widget.getField('NRTAMCODIGO').setValue(tamanho_mascara);
		}
		else if (ordenacao_tipo == "1") {
			widget.getField('NRTAMCODIGO').setValue(0);
		}
	};

	this.concatenaArrayMascara = function(array) {
		arrayString = '';
		for (var pos in array) {
			arrayString += array[pos];
		}
		return arrayString.length;
	};

	this.verificaCheckboxTodos = function(currentRow) {
		if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'N') {

			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');

		}
		else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'N') {

			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');

		}
		else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'S') {

			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = 'REQUEST';

		}
		else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'S') {

			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = 'REQUEST';
		}
	};

	this.tipoProduto = function(widget) {
		var mensagem = "O tipo de produto não foi informado";

		if (!widget.getField('IDNAOESTOC').checked && !widget.getField('IDESTOCAVEL').checked) {
			ScreenService.errorNotification(mensagem);
			return false;
		}
		return true;
	};

	this.exportDateValues = function(field) {
		if (field.value()) {
			field.widget.currentRow.DTINICIAL = field.value().start || '';
			field.widget.currentRow.DTFINAL = field.value().end || '';
		}
	};
	
		this.onClickServico = function(field){
		var widget = field.widget;

		var filterData = {
			CDFILIAL : widget.currentRow.CDFILIAL || '',
			CDGRUPSERV : this.retornaGrupServ(widget.currentRow)
		};

		General.buildDataSourceFilter(field.dataSourceFilter, filterData);
		field.reload();
	};
	
		this.retornaGrupServ = function(currentRow) {
		if (currentRow.ALLGRUPSERV == 'N') {
			if (Array.isArray(currentRow.NMGRUPSERV)) {
				return currentRow.NMGRUPSERV.join('_');
			} else {
				return "";
			}
		} else {
			return 'T';
		}
	};

	this.validaProduto = function(currentRow){
		var result = true;
		if(!General.comparaPratoProduto(currentRow.CDARVPRODINICIAL, currentRow.CDARVPRODFINAL, getLocalVar('CDPICTPROD'))){
			result = false;
			ScreenService.showMessage('O produto inicial deve ser menor ou igual ao produto final!');	
		}
		return result;
	};

	this.setProdFinal = function(field){
		let widget = field.widget;
		widget.currentRow.NMPRODFINAL = angular.copy(widget.currentRow.NMPRODINICIAL);
		widget.currentRow.CDPRODFINAL = angular.copy(widget.currentRow.CDPRODINICIAL);
		widget.currentRow.CDARVPRODFINAL = angular.copy(widget.currentRow.CDARVPRODINICIAL);
	};

	this.validaRelatorio = function(widget, args) {
		if(widget.isValid()){
			currentRow = widget.currentRow;
			reportName = currentRow.REPORT_NAME;
			var reportFormats = [
				{
					name: "pdf",
					value: "PDF"
				},
				{
					name: "xlsx",
					value: "XLSX"
				}
			];
			currentRow.CDPICTPROD = "!" + getLocalVar('CDPICTPROD').replace(/[^(/\.|\ )]/g, "@");

			if (this.tipoProduto(widget) && this.validaData(currentRow) && this.validaProduto(currentRow)) {
				if (widget.isValid()) {
					General.openReportPopup(widget, this.abreRelatorio, [currentRow, args, reportName], reportFormats);
				}
			}
		}
	};

	this.abreRelatorio = function(currentRow, args, reportName) {

		currentRow.DTPERIFINA = currentRow.DTFINAL;
		currentRow.DTPERIINIC = currentRow.DTINICIAL;
		this.verificaCheckboxTodos(currentRow);

		General.openReport('cus_relatorio#/cus01700_custo_real_global', reportName, args.row);

	}.bind(this);
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus01700_CustoRealizadoGlobalDoPeriodo', Cus01700_CustoRealizadoGlobalDoPeriodo);
});